/*************************************************************************
 * La meteo locale extraite du site internet par ESP32, Filtrée ajustée  *
 * et affichée par un écran TFT de 1.8 pouce ! Extraction de données     * 
 * le site : http://api.openweathermap.org/data/2.5/weather?q= , Ce site *          
 * avec une incription gratuite permet d'extraire des données au format  *
 * convertibles et extractibles ... De quoi s'amuser un peu               *
 *************************************************************************
 */ 
 
#include <Adafruit_GFX.h>    // Librairie Graphique

#include <Adafruit_ST7735.h> // Disposition spécifique pour le gestionaire matériel de l'afficheur ST7735

#include <SPI.h>
#include <ArduinoJson.h>          //https://github.com/bblanchon/ArduinoJson.git
#include <NTPClient.h>           //https://github.com/taranais/NTPClient
 
// Pin de raccordement de la gestion de l'afficheur sur l'ESP32
#define TFT_DC     2       // registre du Data Control
#define TFT_RST   4         // Pin de reste de l'afficheur par l'ESP32
#define TFT_CS   5       // Validation de l'affichage 

#include <WiFi.h>
#include <WiFiUdp.h>
#include <HTTPClient.h>

Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS, TFT_DC, TFT_RST); //déclaration de gestion de l'afficheur

 
const char* ssid     = "zzzzzzzzzzzzzzz";// A MODIFIER PAR VOTRE SSID 
const char* password = "yyyyyyyyyyyyyyyyyyyyyyyyyy";// A MODIFIER PAR VOTRE PASSE
String town="Lyon";// A MODIFIER PAR VOTRE VILLE 
String Country="FR";// A MODIFIER SI AUTRE PAYS
const String endpoint = "http://api.openweathermap.org/data/2.5/weather?q="+town+","+Country+"&units=metric&lang=fr&APPID=";
const String key = "ffffffffffffffffffffffffffffffff"; // A MODIFIER PAR LA CLEF DE L'API
String payload=""; // Chaine de caractère entière extraite par json 
String tmp="" ; // temperature
String tmpMin=""; // température mini
String tmpMax=""; // température maxi
String pres="" ; // Pression
String wind="" ; // Vent
String deg="" ;// Sens du vent
String hum="" ; // humidité
String meteo="" ; // nuageux, soleil, couvert, etc
int windSens; // Vitesse du vent en Km/h


// Variables pour l'extraction de l'heure
String formattedTime;
StaticJsonDocument<1000> doc;

// Defini le NTP Client
WiFiUDP ntpUDP;
NTPClient timeClient(ntpUDP);
 
// Variables de boucle et de status des boutons
int i=0;
int count=0;
int press1=0; 

 
void setup(void) {//------------------------------------SETUP--------------------------


// Orientation du registre des entrées des boutons
   pinMode(0,INPUT_PULLUP);

   
// Affichage pour le suivi du processus de connexion   
  tft.initR(INITR_BLACKTAB);
  tft.setRotation(2);
  tft.fillScreen(ST77XX_BLACK);
  tft.setTextColor(ST77XX_WHITE);
  tft.setTextSize(1);

 tft.print("amazing-vacuum-tubes.com");
  tft.print("Connecting to ");
  tft.println(ssid);
  WiFi.begin(ssid, password);
  
  while (WiFi.status() != WL_CONNECTED) {
    delay(300);
    tft.print(".");
  }
  
  tft.println("");
  tft.println("WiFi connected.");
  tft.println("IP address: ");
  tft.println(WiFi.localIP());
  delay(3000);

//Préparation du fond de l'afficheur
  tft.fillScreen(ST77XX_BLACK);
  tft.setCursor(25, 148);
  tft.setTextColor(ST77XX_WHITE);
  tft.println(WiFi.localIP());// Adresse ip en bas d'écran
  tft.setTextColor(ST77XX_WHITE);// Couleur des 4 titres
  tft.setCursor(80, 110);
    tft.println("VENT :");
  tft.setCursor(80, 78);
    tft.println("PRESS :");
  tft.setCursor(4, 78);
    tft.println("TEMP :");
  tft.setCursor(4, 110);
    tft.println("HUM : ");
//Affichage du bled choisi
  tft.setTextColor(ST77XX_YELLOW);
  tft.setTextSize(2);
  tft.setCursor(25, 25); // A ajuster suivant longueur du mot
   tft.println(town);
  tft.fillRect(0,70,128,3,ST77XX_BLUE);// trait separateur en bas (horizontal)
  tft.fillRect(60,70,3,70,ST77XX_BLUE);// trait separateur en bas (vertical)
 
// Initialise le NTPClient pour avoir l'heure
  timeClient.begin(); 
  getData();
  delay(500);
}

 
void loop() {//------------------------------------------LOOP------------------------------
 
    
// Si le bouton 2 est pressé --> affichage de la tempéraure Mini maxi pendant 5 sec 
   if(digitalRead(0)==0){
    if(press1==0){
      press1=1;// anti rebond
        tft.fillRect(0,85,55,20,ST7735_BLACK);//Fond de la température
        tft.setTextSize(1);
        tft.setCursor(3, 90);
        tft.println(tmpMin+"min");
        tft.setCursor(3, 98);
        tft.println(tmpMax+"max");
       delay (5000);
     tft.fillRect(0,85,55,20,ST7735_BLACK);//Fond de la température
    }
   else press1=0;
   }
   
// Boucle d'affichage
   if(count==0) 
     getData();// Va vers le Sous programme d'extractionet mise en forme des valeurs avant affichage
      count++;
   if(count>2000)
     count=0;
      tft.setTextSize(2);
      tft.setCursor(5, 90);
        tft.println(tmp.substring(0,4));//avec 1 chiffre après la virgule
       tft.setCursor(2, 125);
         tft.println(hum+"%");
       tft.setCursor(75, 90);
         tft.println(pres);
// Couleur suivant le sens du vent 
    windSens=(deg.toInt()); //Remplace la chaine de caractère en valeur
      if ((windSens > 300 )and (windSens < 30 )) {
          tft.setTextColor(ST77XX_WHITE);
      } 
      if ((windSens > 29)and (windSens <120) ) {
          tft.setTextColor(ST77XX_RED);
      }
      if ((windSens > 119 )and(windSens < 240)) {
          tft.setTextColor(ST77XX_BLUE);
      }
      if ((windSens > 239) and (windSens < 301)) {
          tft.setTextColor(ST77XX_GREEN);
      }
          tft.setCursor(75, 125);
          tft.println(wind.substring(0,3));

// Mise à jour de l'horloge, tant que ...toujours            
          while(!timeClient.update()) {
          timeClient.forceUpdate();   
  }
     
// L'heure arrive ainsi: 16:00:13
      formattedTime = timeClient.getFormattedTime();
      tft.fillRect(0,0,128,20,ST7735_RED);
      tft.setTextColor(ST77XX_WHITE);
      tft.setTextSize(2);
      tft.setCursor(30, 2);
         tft.println(formattedTime.substring(0,5)); 
     delay(1000);
}

 
void getData()//Mise en forme
{
// Effacement cyclique des données par affichage d'un rectangle noir sur chacune   
  tft.fillRect(0,85,55,20,ST7735_BLACK);//--------------------- Backround de la température
  tft.fillRect(66,85,128,20,ST7735_BLACK);//--------------------- Backround de l'humidité
  tft.fillRect(0,124,55,20,ST7735_BLACK);//--------------------- Backround de la Pression
  tft.fillRect(66,124,128,20,ST7735_BLACK);//--------------------- Backround du vent
delay (300);
   
   if ((WiFi.status() == WL_CONNECTED)) { //Contrôle de l'état de la connexion
 
    HTTPClient http;
 
    http.begin(endpoint + key); //Specify the URL
    int httpCode = http.GET();  //Make the request
    if (httpCode > 0) payload = http.getString();
    http.end(); //Libère les ressources
  }
 char inp[1000];
 payload.toCharArray(inp,1000);
 deserializeJson(doc,inp);
 
 // Offset de l'heure en secondes pour ajuster mon timezone
  // GMT +1 = 3600
  // GMT +2 = 7200
  int Decalage=doc["timezone"]; // heure locale ( en été = 7200)
  timeClient.setTimeOffset(Decalage);
  
  String tmp2 = doc["main"]["temp"];
  String tmp3 = doc["main"]["temp_min"];
  String tmp4 = doc["main"]["temp_max"];
  String pres2 = doc["main"]["pressure"];
  String wind2 = doc["wind"]["speed"];
  String deg2 = doc["wind"]["deg"];
  String hum2 = doc["main"]["humidity"];
  String town2 = doc["name"];
  tmp=tmp2;
  tmpMin=tmp3;
  tmpMax=tmp4;
  hum=hum2;
  pres=pres2;
  wind=((wind2.toInt())* 3.6); //Remplace la chaine de caractère et les m/s par Km/h
  deg=deg2;
  
  
//On sort la meteo en cours 
  String meteo1 = doc["weather"];//                                     
  int test = meteo1.indexOf("description")+14;//14 = chaque lettre du mot "description" en comptant les guillemets !
  String meteo2 = meteo1.substring(test,test+meteo1.length()-1);
  test = meteo2.indexOf(",")-1;
//Sortie de la meteo mais avec des accents
  String meteo = meteo2.substring(0,test);
//    REMPLACEMENT DES ACCENTS PAR LES LETTRES SANS ACCENT
  meteo.replace("é", "e");
  meteo.replace("è", "e");
  meteo.replace("ê", "e");
  meteo.replace("à", "a");
// Affichage de la météo
 tft.fillRect(0,50,128,20,ST7735_BLACK);//--------------------- Backround noir de la météo en lettres 
 tft.setCursor(1, 50);
 tft.setTextSize(2);
 tft.setTextColor( ST77XX_GREEN);//
 tft.println(meteo.substring(0,10));//avec 10 caractères

 } 
